
(function () {
    'use strict';

    var cssFilledBasketClass = function (options) {
        this.init(options);
    };

    cssFilledBasketClass.VERSION = '1.0.0';
    cssFilledBasketClass.DEFAULTS = { 
  			showDebug : false,
  			source: '',
  			minLength: 3,
  			web:'',
  			confirmTemplate: '\
  				<div class="modal fade" id="confirmation_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<form role="form" method="post" action="category_delete" id="delete_data">\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-danger confirmYes" >Ja ich m&ouml;chte</button>\
			    					<button type="button" class="btn btn-primary" data-dismiss="modal">Nein ich m&ouml;chte nicht</button>\
			    				</div>\
			    			</form>\
			    		</div>\
			    	</div>\
			    </div>\
			',
  			noticeTemplate: '\
  				<div class="modal fade " id="css_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<!-- <form role="form" method="post" action="" >\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-default" data-dismiss="modal">schlie&szlig;en</button>\
			    				</div>\
			    			</form>-->\
			    		</div>\
			    	</div>\
			    </div>\
			'
    };
    cssFilledBasketClass.prototype = {

        constructor: cssFilledBasketClass,

        init: function (options) {
            this.options = $.extend({}, cssFilledBasketClass.DEFAULTS, options);
            var that = this;
        },

        register: function(options) {
        	var that=this;
        	this.debug("function register started");
        	that.checkTrashButtonStatus();
        	that.initAutoComplete();
        	that.initCopyLink();
        	that.initActiveSelect();
        	that.initBasketChannel();
        	that.initDeleteButton();
        	
        	$(".basket-list").on("click",".css-plus", function(e) {
        		e.stopPropagation();
        		var el = $(this).closest(".input-group").clone();

        		$(el).find('.css-autocomplete').removeClass("loaded")	;
        		$(el).find('.css-autocomplete').removeClass("autocompleter-node")	;
        		
        		$(el).find("input").each(function() {
        			if($(this).data("default")) {
          			$(this).val($(this).data("default"));
        			} else {
        				$(this).val("");
        			}
        		});
        		$(".basket-list").append(el);	
          	that.checkTrashButtonStatus();
//          	that.initAutoComplete();
        	})
        	
        	$(".basket-list").on("click",".css-minus", function(e) {
        		e.stopPropagation();
        		var el = $(this).closest(".input-group").remove();
        		that.checkTrashButtonStatus();
        	})
        },

        initDeleteButton: function() {
        	var that = this;
        	$("#content").on("click", "button[name='remove']", function() {
        		that.debug("is clicked");

        		if(!$(this).hasClass("confirmed")) {
      				that.openModalConfirmation(this,"alert alert-danger", "Warning", "Sind Sie sicher das Sie diesen Eintrag l&ouml;schen m&ouml;chten?");
        			return;	
      			} else {
      				$("input[name='cssAdminBasket']").val("deleteBasket");
      				$(this).closest("form").submit();
      				};
        	});
        },

        
    		openModalConfirmation: function (el, selector, titel,content) {
    			$("#confirmation_modal").remove();
    			$("body").append(this.options.confirmTemplate);
    			$("#confirmation_modal .modal-content").addClass(selector);
    			$("#confirmation_modal .modal-title").html(titel);
    			$("#confirmation_modal .modal-body").html(content);
    			$("#confirmation_modal .confirmYes").on("click", function() {
    				$(el).addClass("confirmed").trigger("click");
    				$("#confirmation_modal").modal("hide");
    			});
    			$("#confirmation_modal").modal("show");
    		},

        
        initActiveSelect: function() {
          $("#cssActive").on("change", function() {
          	if($(this).val()=='Y') {
          		$(this).removeClass("alert-danger");
          		$(this).addClass("alert-success");
          	} else {

          		$(this).addClass("alert-danger");
          		$(this).removeClass("alert-success");
          	}
          });
        },
        
        initBasketChannel: function() {
        	$("#BasketChannel").on("change",function() {
        		$(this).closest("form").submit();
        	});
        },
        
        initCopyLink: function() {
        	var that = this;
        	
        	$("body").on("click",".copy-angebot", function() {
        		var copyField = $(this).closest(".input-group").find("input[name='url']");
        		var value = $(copyField).val();
        		$(copyField).val(that.options.web +"/" + "angebot_" + value);
        		copyField.select();
        		document.execCommand("copy");
        		$(copyField).val(value).blur();
        	});
        	
        	$("body").on("click",".copy-link", function() {
        		var copyField = $(this).closest(".input-group").find("input[name='url']");
        		var value = $(copyField).val();
        		$(copyField).val(that.options.web +"/" + value);
        		copyField.select();
        		document.execCommand("copy");
        		$(copyField).val(value).blur();
        	});
        },
        
        getSelected: function(el) {
        	console.log(el);
        	var selectedList = $("input.articleId");
        	var list = new Array();
        	if(selectedList.length) {
        		for(var cssCounter = 0; cssCounter<selectedList.length; cssCounter++) {
        			list[cssCounter] = Number($(selectedList[cssCounter]).val());
        		}
        	}
        	return list.join(',');
        },
        
        initAutoComplete: function() {
        	var that = this;
        	that.debug("initialisiere autocomplete");

        	$("body").on("focus",'.css-autocomplete', function() { 
          	$('.css-autocomplete').autocompleter("destroy")	;
        		$('.css-autocomplete').removeClass("autocompleter-node")	;
          	$(".autocompleter").remove();
          	$(this).autocompleter({
	            source: that.options.source,
	            selectFirst:true,
	            forceFixPosition:true,
	            changeWhenSelect:true,
	            focusOpen:true,
	            cache: false,
	            minLength:that.options.minLength,
	            template: '{{ artnr }} - {{ name }}',
	            combine: function(params) {
	            		var isSelected = that.getSelected(this);
	            		var ajaxSearch = true;
	              return {
	                q: params.query,
	                count: params.limit,
	                ajaxSearch: ajaxSearch,
	                isSelected : isSelected
	              };
	            },
	            callback: function(value, index, object) {
	        			    	
	            	$(this).closest(".input-group").find(".articleId").val(object.id);
	            	that.debug(value);
	            	that.debug(object.id);
	            }
        	  });
          });
        },
        
        checkTrashButtonStatus : function() {
      		if($(".basket-list .input-group").length<2) {
      			$(".basket-list .input-group .css-minus").attr("disabled",true);
      		} else {
      			$(".basket-list .input-group .css-minus").attr("disabled",false);
      		}
        },
        
        debug: function(s) {
        	if(this.options.showDebug) {
        		console.log(s);
        	}
        },

    		openModalNotice: function (el, selector, titel,content) {
     			$("#css_modal").remove();
    			$("body").append(this.options.noticeTemplate);
    			if(selector) $("#css_modal .modal-content").addClass(selector);
    			$("#css_modal .modal-title").html(titel);
    			$("#css_modal .modal-body").html(content);
    			$("#css_modal").modal("show");
    		},

    		post_data: function (url, data) {
	      	jQuery.ajax({
					type: 'POST',
					url: url,
					data: data,
					showNoSuggestionNotice: true,
					dataType: 'json',
			    beforeSend: function(jqXHR) {
		        jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
			    },
					success: function(data,responseText,jqXHR) {
						if( jqXHR.status == 204 ) {
							$.cssVouch.debug('sorry, here is nothing to do for me. (Token problem?)')
							return false;
						}
						if( jqXHR.status == 404 ) {
							$.cssVouch.debug('sorry, here is nothing to show you.')
							return false;
						}
						if( jqXHR.status == 403 ) {
							$.cssVouch.debug('sorry, this is no place for you.')
							return false;
						}
						//debug(data);
						if( data.script )	{
							eval(data.script);
						}
            $("body").trigger('contentChanged');
					},
					error: function() {
						this.debug('something is wrong....anything buggy?');
					},
					complete: function() {
							
					}
			});
		},
   };

    $.cssFilledBasket = function(options) {
    	$.cssFB = new cssFilledBasketClass(options);
    	$.cssFB.register();
    	return $.cssFB;
    };
})(jQuery);


var cssHashCode  = function() {
  var hash = 5381, i = this.length
  while(i)
    hash = (hash * 33) ^ this.charCodeAt(--i)
  return hash >>> 0;
};

jQuery(document).ready(function() {
	cssHashCode(document.location.href);
	$('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
	  var target = $(e.target).attr("href") // activated tab
	  $.cookie('target', target, { expires: 7 });
	});

	if($.cookie('target') != 'undefined') {
		$("li.tab a[href='" + $.cookie('target') + "']").tab('show');
	}

	$(".content-header").addClass("css-content");
	
	$(".css-content ").each(function() {
		$(this).html('<div class="inner">' + $(this).html() + '</div>').append('<div class="text-center css-more-button"><span class="fa fa-angle-double-down"></span></div>');
	});

	$(".content-header").prepend($(".css-content .row").remove());
	
	$("body").on("click",".css-more-button", function() {
		$(this).closest(".css-content").addClass("load");
		if($(this).closest(".css-content").hasClass("in")) {
		} else {
			$("body .css-content.in").not(".load").removeClass("in").find(".inner.in").slideUp(500).removeClass("in");
		}
		$(this).closest(".css-content").removeClass("load");
		$(this).closest(".css-content").find(".inner").slideDown(500, function() {
			if($(this).closest(".versandoption").length) {
				 $([document.documentElement, document.body]).animate({
		        scrollTop: $(this).closest(".versandoption").offset().top - 100
		    }, 1000);
			}
			});
		$(this).closest(".css-content").find(".inner.in").slideUp(500);
		$(this).closest(".css-content").find(".inner").toggleClass("in");
		$(this).closest(".css-content").toggleClass("in");
	});

	
});

